diff --git a/db/seeds.d/25-roles.rb b/db/seeds.d/25-roles.rb
new file mode 100644
index 000000000..1852e4910
--- /dev/null
+++ b/db/seeds.d/25-roles.rb
@@ -0,0 +1,70 @@
+# Roles
+default_permissions =
+    { 'Manager'               => [:view_architectures, :create_architectures, :edit_architectures, :destroy_architectures,
+                                  :view_authenticators, :create_authenticators, :edit_authenticators, :destroy_authenticators,
+                                  :view_bookmarks, :create_bookmarks, :edit_bookmarks, :destroy_bookmarks,
+                                  :view_compute_resources, :create_compute_resources, :edit_compute_resources, :destroy_compute_resources,
+                                  :view_compute_resources_vms, :create_compute_resources_vms, :edit_compute_resources_vms, :destroy_compute_resources_vms, :power_compute_resources_vms, :console_compute_resources_vms,
+                                  :view_templates, :create_templates, :edit_templates, :destroy_templates, :deploy_templates,
+                                  :view_domains, :create_domains, :edit_domains, :destroy_domains,
+                                  :view_environments, :create_environments, :edit_environments, :destroy_environments, :import_environments,
+                                  :view_external_variables, :create_external_variables, :edit_external_variables, :destroy_external_variables,
+                                  :view_globals, :create_globals, :edit_globals, :destroy_globals,
+                                  :view_hostgroups, :create_hostgroups, :edit_hostgroups, :destroy_hostgroups,
+                                  :view_hosts, :create_hosts, :edit_hosts, :destroy_hosts, :build_hosts, :power_hosts, :console_hosts, :ipmi_boot, :puppetrun_hosts,
+                                  :edit_classes, :create_params, :edit_params, :destroy_params,
+                                  :view_images, :create_images, :edit_images, :destroy_images,
+                                  :view_locations, :create_locations, :edit_locations, :destroy_locations, :assign_locations,
+                                  :view_media, :create_media, :edit_media, :destroy_media,
+                                  :view_models, :create_models, :edit_models, :destroy_models,
+                                  :view_operatingsystems, :create_operatingsystems, :edit_operatingsystems, :destroy_operatingsystems,
+                                  :view_ptables, :create_ptables, :edit_ptables, :destroy_ptables,
+                                  :view_puppetclasses, :create_puppetclasses, :edit_puppetclasses, :destroy_puppetclasses, :import_puppetclasses,
+                                  :view_smart_proxies, :create_smart_proxies, :edit_smart_proxies, :destroy_smart_proxies,
+                                  :view_smart_proxies_autosign, :create_smart_proxies_autosign, :destroy_smart_proxies_autosign,
+                                  :view_smart_proxies_puppetca, :edit_smart_proxies_puppetca, :destroy_smart_proxies_puppetca,
+                                  :view_subnets, :create_subnets, :edit_subnets, :destroy_subnets, :import_subnets,
+                                  :view_organizations, :create_organizations, :edit_organizations, :destroy_organizations, :assign_organizations,
+                                  :view_usergroups, :create_usergroups, :edit_usergroups, :destroy_usergroups,
+                                  :view_users, :create_users, :edit_users, :destroy_users, :access_settings, :access_dashboard,
+                                  :view_reports, :destroy_reports, :upload_reports,
+                                  :view_facts, :upload_facts, :view_audit_logs,
+                                  :view_statistics, :view_trends, :create_trends, :edit_trends, :destroy_trends, :update_trends,
+                                  :view_tasks, :view_plugins],
+      'Edit partition tables' => [:view_ptables, :create_ptables, :edit_ptables, :destroy_ptables],
+      'View hosts'            => [:view_hosts],
+      'Edit hosts'            => [:view_hosts, :edit_hosts, :create_hosts, :destroy_hosts, :build_hosts],
+      'Viewer'                => [:view_hosts, :view_puppetclasses, :view_hostgroups, :view_domains, :view_operatingsystems,
+                                  :view_locations, :view_media, :view_models, :view_environments, :view_architectures,
+                                  :view_ptables, :view_globals, :view_external_variables, :view_authenticators,
+                                  :access_settings, :access_dashboard, :view_reports, :view_facts, :view_smart_proxies,
+                                  :view_subnets, :view_statistics, :view_organizations, :view_usergroups, :view_users,
+                                  :view_audit_logs],
+      'Site manager'          => [:view_architectures, :view_audit_logs, :view_authenticators, :access_dashboard,
+                                  :view_domains, :view_environments, :import_environments, :view_external_variables,
+                                  :create_external_variables, :edit_external_variables, :destroy_external_variables,
+                                  :view_facts, :view_globals, :view_hostgroups, :view_hosts, :view_smart_proxies_puppetca,
+                                  :view_smart_proxies_autosign, :create_hosts, :edit_hosts, :destroy_hosts,
+                                  :build_hosts, :view_media, :create_media, :edit_media, :destroy_media,
+                                  :view_models, :view_operatingsystems, :view_ptables, :view_puppetclasses,
+                                  :import_puppetclasses, :view_reports, :destroy_reports, :access_settings,
+                                  :view_smart_proxies, :edit_smart_proxies, :view_subnets, :edit_subnets,
+                                  :view_statistics, :view_usergroups, :create_usergroups, :edit_usergroups,
+                                  :destroy_usergroups, :view_users, :edit_users],
+    }
+
+default_user_permissions = [:view_hosts, :view_puppetclasses, :view_hostgroups, :view_domains,
+                            :view_operatingsystems, :view_media, :view_models, :view_environments,
+                            :view_architectures, :view_ptables, :view_globals, :view_external_variables,
+                            :view_authenticators, :access_settings, :access_dashboard,
+                            :view_reports, :view_subnets, :view_facts, :view_locations,
+                            :view_organizations, :view_statistics]
+anonymous_permissions    = [:view_hosts, :view_bookmarks, :view_tasks]
+
+Role.without_auditing do
+  default_permissions.each do |role_name, permission_names|
+    create_role(role_name, permission_names, 0)
+  end
+  create_role('Default user', default_user_permissions, Role::BUILTIN_DEFAULT_USER)
+  create_role('Anonymous', anonymous_permissions, Role::BUILTIN_ANONYMOUS)
+end
diff --git a/db/seeds.rb b/db/seeds.rb
index 1a9a051d0..8c9301103 100644
--- a/db/seeds.rb
+++ b/db/seeds.rb
@@ -5,6 +5,8 @@
 #
 # Please ensure that all templates are submitted to community-templates, then they will be synced in.
 
+# define all helpers here
+
 def format_errors(model = nil)
   return '(nil found)' if model.nil?
   model.errors.full_messages.join(';')
@@ -20,161 +22,34 @@ def audit_modified?(type, name)
   false
 end
 
-# Architectures
-Architecture.without_auditing do
-  Architecture.find_or_create_by_name "x86_64"
-  Architecture.find_or_create_by_name "i386"
-end
-
-# Template kinds
-kinds = {}
-[:PXELinux, :PXEGrub, :iPXE, :provision, :finish, :script, :user_data, :ZTP].each do |type|
-  kinds[type] = TemplateKind.find_by_name(type)
-  kinds[type] ||= TemplateKind.create :name => type
-  raise "Unable to create template kind: #{format_errors kinds[type]}" if kinds[type].nil? || kinds[type].errors.any?
-end
-
-# Find known operating systems for associations
-os_junos = Operatingsystem.find_all_by_type "Junos" || Operatingsystem.where("name LIKE ?", "junos")
-os_solaris = Operatingsystem.find_all_by_type "Solaris"
-os_suse = Operatingsystem.find_all_by_type "Suse" || Operatingsystem.where("name LIKE ?", "suse")
-os_windows = Operatingsystem.find_all_by_type "Windows"
-
-# Partition tables
-Ptable.without_auditing do
-  [
-    { :name => 'AutoYaST entire SCSI disk', :os_family => 'Suse', :source => 'autoyast/disklayout_scsi.erb' },
-    { :name => 'AutoYaST entire virtual disk', :os_family => 'Suse', :source => 'autoyast/disklayout_virtual.erb' },
-    { :name => 'AutoYaST LVM', :os_family => 'Suse', :source => 'autoyast/disklayout_lvm.erb' },
-    { :name => 'Jumpstart default', :os_family => 'Solaris', :source => 'jumpstart/disklayout.erb' },
-    { :name => 'Jumpstart mirrored', :os_family => 'Solaris', :source => 'jumpstart/disklayout_mirrored.erb' },
-    { :name => 'Kickstart default', :os_family => 'Redhat', :source => 'kickstart/disklayout.erb' },
-    { :name => 'Preseed default', :os_family => 'Debian', :source => 'preseed/disklayout.erb' },
-    { :name => 'Preseed custom LVM', :os_family => 'Debian', :source => 'preseed/disklayout_lvm.erb' },
-    { :name => 'Junos default fake', :os_family => 'Junos', :source => 'ztp/disklayout.erb' }
-  ].each do |input|
-    next if Ptable.find_by_name(input[:name])
-    next if audit_modified? Ptable, input[:name]
-    p = Ptable.create({
-      :layout => File.read(File.join("#{Rails.root}/app/views/unattended", input.delete(:source)))
-    }.merge(input))
-    raise "Unable to create partition table: #{format_errors p}" if p.nil? || p.errors.any?
-  end
-end
-
-# Provisioning templates
-ConfigTemplate.without_auditing do
-  [
-    # Generic PXE files
-    { :name => 'PXELinux global default', :source => 'pxe/PXELinux_default.erb', :template_kind => kinds[:PXELinux] },
-    { :name => 'PXELinux default local boot', :source => 'pxe/PXELinux_local.erb', :template_kind => kinds[:PXELinux] },
-    { :name => 'PXEGrub default local boot', :source => 'pxe/PXEGrub_local.erb', :template_kind => kinds[:PXEGrub] },
-    # OS specific files
-    { :name => 'AutoYaST default', :source => 'autoyast/provision.erb', :template_kind => kinds[:provision], :operatingsystems => os_suse },
-    { :name => 'AutoYaST SLES default', :source => 'autoyast/provision_sles.erb', :template_kind => kinds[:provision], :operatingsystems => os_suse },
-    { :name => 'AutoYaST default PXELinux', :source => 'autoyast/PXELinux.erb', :template_kind => kinds[:PXELinux], :operatingsystems => os_suse },
-    { :name => 'Grubby default', :source => 'scripts/grubby.erb', :template_kind => kinds[:script] },
-    { :name => 'Jumpstart default', :source => 'jumpstart/provision.erb', :template_kind => kinds[:provision], :operatingsystems => os_solaris },
-    { :name => 'Jumpstart default finish', :source => 'jumpstart/finish.erb', :template_kind => kinds[:finish], :operatingsystems => os_solaris },
-    { :name => 'Jumpstart default PXEGrub', :source => 'jumpstart/PXEGrub.erb', :template_kind => kinds[:PXEGrub], :operatingsystems => os_solaris },
-    { :name => 'Kickstart default', :source => 'kickstart/provision.erb', :template_kind => kinds[:provision] },
-    { :name => 'Kickstart RHEL default', :source => 'kickstart/provision_rhel.erb', :template_kind => kinds[:provision] },
-    { :name => 'Kickstart default PXELinux', :source => 'kickstart/PXELinux.erb', :template_kind => kinds[:PXELinux] },
-    { :name => 'Kickstart default iPXE', :source => 'kickstart/iPXE.erb', :template_kind => kinds[:iPXE] },
-    { :name => 'Kickstart default user data', :source => 'kickstart/userdata.erb', :template_kind => kinds[:user_data] },
-    { :name => 'Preseed default', :source => 'preseed/provision.erb', :template_kind => kinds[:provision] },
-    { :name => 'Preseed default finish', :source => 'preseed/finish.erb', :template_kind => kinds[:finish] },
-    { :name => 'Preseed default PXELinux', :source => 'preseed/PXELinux.erb', :template_kind => kinds[:PXELinux] },
-    { :name => 'Preseed default iPXE', :source => 'preseed/iPXE.erb', :template_kind => kinds[:iPXE] },
-    { :name => 'Preseed default user data', :source => 'preseed/userdata.erb', :template_kind => kinds[:user_data] },
-    { :name => 'WAIK default PXELinux', :source => 'waik/PXELinux.erb', :template_kind => kinds[:PXELinux], :operatingsystems => os_windows },
-    { :name => "Junos default SLAX", :source => 'ztp/provision.erb', :template_kind => kinds[:provision], :operatingsystems => os_junos },
-    { :name => "Junos default ZTP config", :source => 'ztp/ZTP.erb', :template_kind => kinds[:ZTP], :operatingsystems => os_junos },
-    { :name => "Junos default finish", :source => 'ztp/finish.erb', :template_kind => kinds[:finish], :operatingsystems => os_junos },
-    # snippets
-    { :name => 'epel', :source => 'snippets/_epel.erb', :snippet => true },
-    { :name => 'fix_hosts', :source => 'snippets/_fix_hosts.erb', :snippet => true },
-    { :name => 'http_proxy', :source => 'snippets/_http_proxy.erb', :snippet => true },
-    { :name => 'puppet.conf', :source => 'snippets/_puppet.conf.erb', :snippet => true },
-    { :name => 'redhat_register', :source => 'snippets/_redhat_register.erb', :snippet => true }
-  ].each do |input|
-    next if ConfigTemplate.find_by_name(input[:name])
-    next if audit_modified? ConfigTemplate, input[:name]
-    t = ConfigTemplate.create({
-      :snippet  => false,
-      :template => File.read(File.join("#{Rails.root}/app/views/unattended", input.delete(:source)))
-    }.merge(input))
-    raise "Unable to create template #{t.name}: #{format_errors t}" if t.nil? || t.errors.any?
-  end
-end
+def create_filters(role, collection)
+  collection.group_by(&:resource_type).each do |resource, permissions|
+    filter      = Filter.new
+    filter.role = role
 
-# Installation media: default mirrors
-Medium.without_auditing do
-  [
-    { :name => "CentOS mirror", :os_family => "Redhat", :path => "http://mirror.centos.org/centos/$major.$minor/os/$arch" },
-    { :name => "Debian mirror", :os_family => "Debian", :path => "http://ftp.debian.org/debian/" },
-    { :name => "Fedora mirror", :os_family => "Redhat", :path => "http://dl.fedoraproject.org/pub/fedora/linux/releases/$major/Fedora/$arch/os/" },
-    { :name => "OpenSUSE mirror", :os_family => "Suse", :path => "http://download.opensuse.org/distribution/$major.$minor/repo/oss", :operatingsystems => os_suse },
-    { :name => "Ubuntu mirror", :os_family => "Debian", :path => "http://archive.ubuntu.com/ubuntu/" }
-  ].each do |input|
-    next if Medium.where(['name = ? OR path = ?', input[:name], input[:path]]).any?
-    next if audit_modified? Medium, input[:name]
-    m = Medium.create input
-    raise "Unable to create medium: #{format_errors m}" if m.nil? || m.errors.any?
-  end
-end
+    permissions.each do |permission|
+      filtering            = filter.filterings.build
+      filtering.permission = permission
+    end
 
-# Bookmarks
-Bookmark.without_auditing do
-  [
-    { :name => "eventful", :query => "eventful = true", :controller=> "reports" },
-    { :name => "active", :query => 'last_report > "35 minutes ago" and (status.applied > 0 or status.restarted > 0)', :controller=> "hosts" },
-    { :name => "out of sync", :query => 'last_report < "30 minutes ago" andstatus.enabled = true', :controller=> "hosts" },
-    { :name => "error", :query => 'last_report > "35 minutes ago" and (status.failed > 0 or status.failed_restarts > 0 or status.skipped > 0)', :controller=> "hosts" },
-    { :name => "disabled", :query => 'status.enabled = false', :controller=> "hosts" },
-    { :name => "ok hosts", :query => 'last_report > "35 minutes ago" and status.enabled = true and status.applied = 0 and status.failed = 0 and status.pending = 0', :controller=> "hosts" }
-  ].each do |input|
-    next if Bookmark.find_by_name(input[:name])
-    next if audit_modified? Bookmark, input[:name]
-    b = Bookmark.create({ :public => true }.merge(input))
-    raise "Unable to create bookmark: #{format_errors b}" if b.nil? || b.errors.any?
+    filter.save!
   end
 end
 
-# Proxy features
-[ "TFTP", "DNS", "DHCP", "Puppet", "Puppet CA", "BMC", "Chef Proxy" ].each do |input|
-  f = Feature.find_or_create_by_name(input)
-  raise "Unable to create proxy feature: #{format_errors f}" if f.nil? || f.errors.any?
-end
-
-AuthSource.without_auditing do
-  # Auth sources
-  src = AuthSourceInternal.find_by_type "AuthSourceInternal"
-  src ||= AuthSourceInternal.create :name => "Internal"
+def create_role(role_name, permission_names, builtin)
+  return if Role.find_by_name(role_name)
+  return if audit_modified? Role, role_name && builtin == 0
 
-  # Users
-  unless User.find_by_login("admin").present?
-    User.without_auditing do
-      user = User.new(:login => "admin", :firstname => "Admin", :lastname => "User", :mail => Setting[:administrator])
-      user.admin = true
-      user.auth_source = src
-      user.password = "changeme"
-      User.current = user
-      raise "Unable to create admin user: #{format_errors user}" unless user.save
-    end
-  end
+  role         = Role.new(:name => role_name)
+  role.builtin = builtin
+  role.save!
+  permissions = Permission.find_all_by_name permission_names
+  create_filters(role, permissions)
 end
 
-# Compute Profiles - only create if there are not any
-if ComputeProfile.unconfigured?
-  ComputeProfile.without_auditing do
-    [
-      { :name => '1-Small' },
-      { :name => '2-Medium' },
-      { :name => '3-Large' },
-    ].each do |input|
-      cp = ComputeProfile.create input
-      raise "Unable to create hardware profile: #{format_errors m}" if cp.nil? || cp.errors.any?
-    end
-  end
+# now we load all seed files
+Dir.glob(Rails.root + 'db/seeds.d/*.rb').sort.each do |seed|
+  puts "Seeding #{seed}"
+  load seed
 end
+puts "All seed files executed"
diff --git a/foreman.spec b/foreman.spec
index 94d0d295a..a392cf840 100644
--- a/foreman.spec
+++ b/foreman.spec
@@ -77,6 +77,7 @@ Requires: %{?scl_prefix}rubygem(jquery-ui-rails)
 Requires: %{?scl_prefix}rubygem(bootstrap-sass) >= 3.0.3.0
 Requires: %{?scl_prefix}rubygem(bootstrap-sass) < 3.0.4
 Requires: %{?scl_prefix}rubygem(foreigner) >= 1.4.2
+Requires: %{?scl_prefix}rubygem(deep_cloneable)
 BuildRequires: %{?scl_prefix}rubygem(ancestry) >= 2.0.0
 BuildRequires: %{?scl_prefix}rubygem(ancestry) < 3.0.0
 BuildRequires: %{?scl_prefix}rubygem(apipie-rails) >= 0.0.23
@@ -114,6 +115,7 @@ BuildRequires: %{?scl_prefix}rubygem(flot-rails) = 0.0.3
 BuildRequires: %{?scl_prefix}rubygem(foreigner) >= 1.4.2
 BuildRequires: %{?scl_prefix}rubygem(multi-select-rails) >= 0.9.10
 BuildRequires: %{?scl_prefix}rubygem(multi-select-rails) < 0.10.0
+BuildRequires: %{?scl_prefix}rubygem(deep_cloneable)
 BuildRequires: %{?scl_prefix}facter
 BuildRequires: gettext
 BuildRequires: asciidoc
@@ -452,12 +454,13 @@ ln -sv %{_sysconfdir}/%{name}/$i %{buildroot}%{_datadir}/%{name}/config/$i
 done
 
 # Put db in %{_localstatedir}/lib/%{name}/db
-cp -pr db/migrate db/seeds.rb %{buildroot}%{_datadir}/%{name}
+cp -pr db/migrate db/seeds.rb db/seeds.d %{buildroot}%{_datadir}/%{name}
 mkdir %{buildroot}%{_localstatedir}/lib/%{name}/db
 
 ln -sv %{_localstatedir}/lib/%{name}/db %{buildroot}%{_datadir}/%{name}/db
 ln -sv %{_datadir}/%{name}/migrate %{buildroot}%{_localstatedir}/lib/%{name}/db/migrate
 ln -sv %{_datadir}/%{name}/seeds.rb %{buildroot}%{_localstatedir}/lib/%{name}/db/seeds.rb
+ln -sv %{_datadir}/%{name}/seeds.d %{buildroot}%{_localstatedir}/lib/%{name}/db/seeds.d
 
 # Put HTML %{_localstatedir}/lib/%{name}/public
 cp -pr public %{buildroot}%{_localstatedir}/lib/%{name}/
diff --git a/lib/core_extensions.rb b/lib/core_extensions.rb
index 7e9934c54..02ecc2f8a 100644
--- a/lib/core_extensions.rb
+++ b/lib/core_extensions.rb
@@ -1,3 +1,4 @@
+require 'tsort'
 # Add an empty method to nil. Now no need for if x and x.empty?. Just x.empty?
 class NilClass
   def empty?
@@ -51,6 +52,48 @@ class ActiveRecord::Base
     end
   end
 
+  class EnsureNoCycle
+    include TSort
+
+    def initialize(base, source, target)
+      @source = source; @target = target
+      @base  = base.map { |record| [record.send(@source), record.send(@target)] }
+      @nodes = @base.flatten.uniq
+      @graph = Hash.new { |h, k| h[k] = [] }
+      @base.each { |s, t| @graph[s]<< t }
+    end
+
+    def tsort_each_node(&block)
+      @nodes.each(&block)
+    end
+
+    def tsort_each_child(node, &block)
+      @graph[node].each(&block)
+    end
+
+    def ensure(record)
+      @record = record
+      add_new_edges
+      detect_cycle
+    end
+
+    private
+
+    def add_new_edges
+      edges = @graph[@record.send(@source) || 0]
+      edges<< @record.send(@target) unless edges.include?(@record.send(@target))
+    end
+
+    def detect_cycle
+      if strongly_connected_components.any? { |component| component.size > 1 }
+        @record.errors.add :base, _("Adding would cause a cycle!")
+        raise ::Foreman::CyclicGraphException, @record
+      else
+        true
+      end
+    end
+  end
+
   def id_and_type
     "#{id}-#{self.class.table_name.humanize}"
   end
diff --git a/lib/foreman/exception.rb b/lib/foreman/exception.rb
index 35ef4da7d..6f0e8f5a6 100644
--- a/lib/foreman/exception.rb
+++ b/lib/foreman/exception.rb
@@ -42,4 +42,7 @@ module Foreman
     end
   end
 
+  class CyclicGraphException < ::ActiveRecord::RecordInvalid
+  end
+
 end
diff --git a/lib/tasks/backup.rake b/lib/tasks/backup.rake
new file mode 100644
index 000000000..7dbb37c04
--- /dev/null
+++ b/lib/tasks/backup.rake
@@ -0,0 +1,75 @@
+namespace :db do
+  desc "Make a dump of your database"
+  task :dump => :environment do
+    config      = Rails.configuration.database_configuration[Rails.env]
+    backup_name = "foreman.#{Time.now.to_i}.sql"
+    case config['adapter']
+    when 'mysql', 'mysql2'
+      mysql_dump(backup_name, config)
+    when 'postgresql'
+      postgres_dump(backup_name, config)
+    when 'sqlite'
+      backup_name = "foreman.#{Time.now.to_i}.sqlite_copy"
+      sqlite_dump(backup_name, config)
+    else
+      puts 'Your database is not supported by Foreman.' and exit(1)
+    end
+
+    puts "Backup in file #{backup_name}"
+  end
+
+  def mysql_dump(name, config)
+    cmd = "mysqldump --opt #{config['database']} -u #{config['username']} "
+    cmd += " -p#{config['password']} " if config['password'].present?
+    cmd += " -h #{config['host']} "    if config['host'].present?
+    cmd += " -P #{config['port']} "    if config['port'].present?
+    cmd += " > #{name}"
+    system(cmd)
+  end
+
+  def postgres_dump(name, config)
+    cmd = "pg_dump -Fc #{config['database']} -U #{config['username']} "
+    cmd += " -h #{config['host']} "    if config['host'].present?
+    cmd += " -p #{config['port']} "    if config['port'].present?
+    cmd += " > #{name}"
+    system({'PGPASSWORD' => config['password']}, cmd)
+  end
+
+  def sqlite_dump(name, config)
+    FileUtils.cp config['database'], name
+  end
+
+  desc 'Import your database dump'
+  task :import_dump => :environment do
+    puts "Run this task with a file argument with the location of your db dump,
+          'rake db:import_dump file=DBDUMPLOCATION" and return unless ENV['file']
+    config = Rails.configuration.database_configuration[Rails.env]
+
+    case config['adapter']
+    when 'mysql', 'mysql2'
+      mysql_import(ENV['file'], config)
+    when 'postgresql'
+      postgres_import(ENV['file'], config)
+    else
+      puts 'Your database dump cannot be imported by Foreman.' and exit(1)
+    end
+  end
+
+  def mysql_import(file, config)
+    cmd = "mysql #{config['database']} -u #{config['username']} "
+    cmd += " -p#{config['password']} " if config['password'].present?
+    cmd += " -h #{config['host']} "    if config['host'].present?
+    cmd += " -P #{config['port']} "    if config['port'].present?
+    cmd += " < #{file}"
+    system(cmd)
+  end
+
+  def postgres_import(file, config)
+    cmd = "pg_restore -d #{config['database']} -U #{config['username']} "
+    cmd += " -h #{config['host']} " if config['host'].present?
+    cmd += " -p #{config['port']} " if config['port'].present?
+    cmd += " #{file}"
+    system({'PGPASSWORD' => config['password']}, cmd)
+    system(cmd)
+  end
+end
diff --git a/lib/tasks/fix_cache.rake b/lib/tasks/fix_cache.rake
new file mode 100644
index 000000000..8244f80e7
--- /dev/null
+++ b/lib/tasks/fix_cache.rake
@@ -0,0 +1,22 @@
+desc 'Fix user groups and authorization cache by removing all cached records and recreating them'
+task :fix_db_cache => :environment do
+  puts 'Recreating cache'
+  CacheManager.recache!
+end
+
+namespace :fix_db_cache do
+  task :delete_old_cache do
+    CacheManager.delete_old_permission_cache
+    puts "Old cached records were deleted"
+  end
+
+  task :create_new_cache do
+    CacheManager.create_new_permission_cache
+    puts "New cached records were saved"
+  end
+
+  task :cache_filter_searches do
+    CacheManager.create_new_filter_cache
+    puts "Filters cache saved"
+  end
+end
diff --git a/test/factories/architecture.rb b/test/factories/architecture.rb
new file mode 100644
index 000000000..e49367500
--- /dev/null
+++ b/test/factories/architecture.rb
@@ -0,0 +1,5 @@
+FactoryGirl.define do
+  factory :architecture do
+    sequence(:name) {|n| "arm#{n}" }
+  end
+end
diff --git a/test/factories/domain.rb b/test/factories/domain.rb
new file mode 100644
index 000000000..0f9b0d515
--- /dev/null
+++ b/test/factories/domain.rb
@@ -0,0 +1,6 @@
+FactoryGirl.define do
+  factory :domain do
+    sequence(:name) {|n| "example#{n}.com" }
+    fullname { |n| n.name }
+  end
+end
diff --git a/test/factories/taxonomies.rb b/test/factories/taxonomies.rb
new file mode 100644
index 000000000..afa65da8d
--- /dev/null
+++ b/test/factories/taxonomies.rb
@@ -0,0 +1,9 @@
+FactoryGirl.define do
+  factory :organization do
+    sequence(:name) { |n| "org#{n}" }
+  end
+
+  factory :location do
+    sequence(:name) { |n| "loc#{n}" }
+  end
+end
diff --git a/test/factories/user_related.rb b/test/factories/user_related.rb
new file mode 100644
index 000000000..783a6e073
--- /dev/null
+++ b/test/factories/user_related.rb
@@ -0,0 +1,80 @@
+FactoryGirl.define do
+  factory :usergroup do
+    sequence(:name) {|n| "usergroup#{n}" }
+  end
+
+  factory :user do
+    auth_source { AuthSourceInternal.first }
+    password 'password'
+    sequence(:login) {|n| "user#{n}" }
+
+    trait :with_mail do
+      sequence(:mail) {|n| "email#{n}@example.com" }
+    end
+  end
+
+  factory :permission do
+    sequence(:name) {|n| "view_#{n}" }
+    resource_type nil
+
+    trait :host do
+      resource_type 'Host'
+    end
+
+    trait :domain do
+      resource_type 'Domain'
+    end
+
+    trait :architecture do
+      resource_type 'Architecture'
+    end
+  end
+
+  factory :role do
+    sequence(:name) {|n| "role #{n}" }
+    builtin 0
+  end
+
+  factory :user_role do
+    role { FactoryGirl.create :role }
+
+    factory :user_user_role do
+      owner { FactoryGirl.create :user }
+    end
+
+    factory :user_group_user_role do
+      owner { FactoryGirl.create :usergroup }
+    end
+  end
+
+  factory :usergroup_member do
+    usergroup { FactoryGirl.create :usergroup }
+
+    factory :user_usergroup_member do
+      member { FactoryGirl.create :user }
+    end
+
+    factory :usergroup_usergroup_member do
+      member { FactoryGirl.create :usergroup }
+    end
+  end
+
+  factory :filter do
+    search nil
+    role { FactoryGirl.create :role }
+    permissions { [ FactoryGirl.create(:permission, :host) ] }
+
+    trait :on_name_all do
+      search 'name ~ *'
+    end
+
+    trait :on_name_starting_with_a do
+      search 'name ~ a*'
+    end
+
+    trait :on_name_starting_with_b do
+      search 'name ~ b*'
+    end
+  end
+
+end
diff --git a/test/functional/api/v1/compute_resources_controller_test.rb b/test/functional/api/v1/compute_resources_controller_test.rb
index 68755ed6e..230a01fe5 100644
--- a/test/functional/api/v1/compute_resources_controller_test.rb
+++ b/test/functional/api/v1/compute_resources_controller_test.rb
@@ -48,59 +48,52 @@ class Api::V1::ComputeResourcesControllerTest < ActionController::TestCase
   end
 
   test "should get index of owned" do
-    as_user(:restricted) do
-      get :index, {}
-    end
+    setup_user 'view', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    get :index, {}
     assert_response :success
     assert_not_nil assigns(:compute_resources)
     compute_resources = ActiveSupport::JSON.decode(@response.body)
     ids               = compute_resources.map { |hash| hash['compute_resource']['id'] }
-    assert !ids.include?(compute_resources(:mycompute).id)
-    assert ids.include?(compute_resources(:yourcompute).id)
+    assert_includes ids, compute_resources(:mycompute).id
+    refute_includes ids, compute_resources(:yourcompute).id
   end
 
   test "should allow access to a compute resource for owner" do
-    as_user(:restricted) do
-      get :show, { :id => compute_resources(:yourcompute).to_param }
-    end
+    setup_user 'view', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    get :show, { :id => compute_resources(:mycompute).to_param }
     assert_response :success
   end
 
   test "should update compute resource for owner" do
-    as_user(:restricted) do
-      put :update, { :id => compute_resources(:yourcompute).to_param, :compute_resource => { :description => "new_description" } }
-    end
-    assert_equal "new_description", ComputeResource.find_by_name('yourcompute').description
+    setup_user 'edit', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    put :update, { :id => compute_resources(:mycompute).to_param, :compute_resource => { :description => "new_description" } }
+    assert_equal "new_description", ComputeResource.find_by_name('mycompute').description
     assert_response :success
   end
 
   test "should destroy compute resource for owner" do
     assert_difference('ComputeResource.count', -1) do
-      as_user(:restricted) do
-        delete :destroy, { :id => compute_resources(:yourcompute).id }
-      end
+      setup_user 'destroy', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+      delete :destroy, { :id => compute_resources(:mycompute).id }
     end
     assert_response :success
   end
 
   test "should not allow access to a compute resource out of users compute resources scope" do
-    as_user(:restricted) do
-      get :show, { :id => compute_resources(:one).to_param }
-    end
+    setup_user 'view', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    get :show, { :id => compute_resources(:one).to_param }
     assert_response :not_found
   end
 
   test "should not update compute resource for restricted" do
-    as_user(:restricted) do
-      put :update, { :id => compute_resources(:mycompute).to_param, :compute_resource => { :description => "new_description" } }
-    end
+    setup_user 'edit', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    put :update, { :id => compute_resources(:yourcompute).to_param, :compute_resource => { :description => "new_description" } }
     assert_response :not_found
   end
 
   test "should not destroy compute resource for restricted" do
-    as_user(:restricted) do
-      delete :destroy, { :id => compute_resources(:mycompute).id }
-    end
+    setup_user 'destroy', 'compute_resources', "id = #{compute_resources(:mycompute).id}"
+    delete :destroy, { :id => compute_resources(:yourcompute).id }
     assert_response :not_found
   end
 
